package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.AlarmRuleFenceRelServiceI;
import com.zcloud.personnel.positioning.dto.AlarmRuleFenceRelAddCmd;
import com.zcloud.personnel.positioning.dto.AlarmRuleFenceRelPageQry;
import com.zcloud.personnel.positioning.dto.AlarmRuleFenceRelUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.AlarmRuleFenceRelCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "告警规则围栏关联")
@RequestMapping("/${application.gateway}/alarmRuleFenceRel")
@RestController
@AllArgsConstructor
public class AlarmRuleFenceRelController {
    private final AlarmRuleFenceRelServiceI alarmRuleFenceRelService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<AlarmRuleFenceRelCO> add(@Validated @RequestBody AlarmRuleFenceRelAddCmd cmd) {
        fillCorpinfo(cmd);
        return alarmRuleFenceRelService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<AlarmRuleFenceRelCO> page(@RequestBody AlarmRuleFenceRelPageQry qry) {
        return alarmRuleFenceRelService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<AlarmRuleFenceRelCO> listAll() {
        return MultiResponse.of(alarmRuleFenceRelService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<AlarmRuleFenceRelCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(alarmRuleFenceRelService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        alarmRuleFenceRelService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        alarmRuleFenceRelService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody AlarmRuleFenceRelUpdateCmd cmd) {
        fillCorpinfo(cmd);
        alarmRuleFenceRelService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(AlarmRuleFenceRelAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(AlarmRuleFenceRelUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
